// BonTuner.cpp: CBonTuner NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Resource.h"
#include "BonTuner.h"

#pragma comment( lib, "winmm.lib" )


//////////////////////////////////////////////////////////////////////
// 萔`
//////////////////////////////////////////////////////////////////////

// MTCY
#define TSDATASIZE			65536UL										// TSf[^̃TCY

// FIFOobt@ݒ
#define ASYNCBUFFTIME		4UL											// obt@ = 4b
#define ASYNCBUFFSIZE		( 0x800000 / TSDATASIZE * ASYNCBUFFTIME )	// 64MbpsƂ

//////////////////////////////////////////////////////////////////////
// TSpPbg
//////////////////////////////////////////////////////////////////////
typedef struct {
	BYTE sync : 8 ;
	BYTE PID_h : 5 ;
	BYTE transport_priority : 1 ;
	BYTE payload_unit_start_indicator : 1 ;
	BYTE transport_error_indicator : 1 ;
	BYTE PID_l : 8 ;
	BYTE continuity_counter : 4 ;
	BYTE adaptation_field_control : 2 ;
	BYTE transport_scrambling_control : 2 ;
	BYTE adaptation_field_length : 8 ;
	BYTE adaptation_field_extension_flag : 1 ;
	BYTE transport_private_data_flag : 1 ;
	BYTE splicing_point_flag : 1 ;
	BYTE OPCR_flag : 1 ;
	BYTE PCR_flag : 1 ;
	BYTE elementary_stream_priority_indicator : 1 ;
	BYTE random_access_indicator : 1 ;
	BYTE discontinuity_indicator : 1 ;
	BYTE PCR_90KHz_1 : 8 ;
	BYTE PCR_90KHz_2 : 8 ;
	BYTE PCR_90KHz_3 : 8 ;
	BYTE PCR_90KHz_4 : 8 ;
	BYTE PCR_27MHz_1 : 7 ;
	BYTE PCR_90KHz_5 : 1 ;
	BYTE OPCR_1 : 6 ;
	BYTE PCR_27MHz_2 : 2 ;
} Packet ;

//////////////////////////////////////////////////////////////////////
// fobOp
//////////////////////////////////////////////////////////////////////

void DebugPrintF( const char* pszFormat,... )
{
	va_list	marker ;
	char edit_str[4096] ;
	va_start( marker, pszFormat ) ;
	vsprintf_s( edit_str, sizeof(edit_str), pszFormat, marker ) ;
	va_end( marker ) ;
	OutputDebugStringA( edit_str ) ;
}

//////////////////////////////////////////////////////////////////////
// CX^X\bh
//////////////////////////////////////////////////////////////////////

#pragma warning( disable : 4273 )

extern "C" __declspec(dllexport) IBonDriver * CreateBonDriver()
{
	LogPrintf( "\fCreateBonDriver()Ăяo\n" ) ;
	// X^X(̏ꍇ̓CX^X̃|C^Ԃ)
	return (CBonTuner::m_pThis)? CBonTuner::m_pThis : ((IBonDriver *) new CBonTuner);
}

#pragma warning( default : 4273 )


//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

// ÓIo
CBonTuner * CBonTuner::m_pThis = NULL;
HINSTANCE CBonTuner::m_hModule = NULL;

CBonTuner::CBonTuner()
{
	m_pThis = this;
	m_hFile = NULL ;
	m_hSemaphore = NULL ;
	m_hThreadEvent = NULL ;
	m_hThread = NULL ;
}

CBonTuner::~CBonTuner()
{
	// JĂꍇ͕
	CloseTuner();
	m_pThis = NULL;
}

const BOOL CBonTuner::OpenTuner()
{
	LogPrintf( "\fCBonTuner::OpenTuner()Ăяo\n" ) ;
	// UN[Y
	CloseTuner();
	// t@CĐ̏
	if ( !Setup() ) return FALSE ;

	return TRUE;
}

void CBonTuner::CloseTuner()
{
	Cleanup() ;
}

const BOOL CBonTuner::SetChannel(const BYTE bCh)
{
	LogPrintf( "\fCBonTuner::SetChannel(%d)Ăяo\n", bCh ) ;
	m_bChValid = TRUE ;
	return TRUE ;
}

const float CBonTuner::GetSignalLevel(void)
{
	return 0.0 ;
}

const DWORD CBonTuner::WaitTsStream(const DWORD dwTimeOut)
{
	return WAIT_OBJECT_0 ;
}

const DWORD CBonTuner::GetReadyCount()
{
	return 1 ;
}

const BOOL CBonTuner::GetTsStream(BYTE *pDst, DWORD *pdwSize, DWORD *pdwRemain)
{
	// TSf[^obt@o
	BYTE *pSrc = NULL;
	if(GetTsStream(&pSrc, pdwSize, pdwRemain)){
		if(*pdwSize){
			::CopyMemory(pDst, pSrc, *pdwSize);
		}
		return TRUE;
	}
	return FALSE;
}

const BOOL CBonTuner::GetTsStream(BYTE **ppDst, DWORD *pdwSize, DWORD *pdwRemain)
{
	// SetChannel܂ł̓Xg[ǂ܂Ȃ
	if ( !m_bChValid ) {
		*pdwSize = *pdwRemain = 0 ;
		return TRUE ;
	}
	// 1010ԂăXbh@^
	static int nCount = 0 ;
	if ( ++nCount >= 10 ) {
		nCount = 0 ;
		*pdwSize = *pdwRemain = 0 ;
		return TRUE ;
	}
	// t@Cǂݎ
	if ( ReadFile() ) {
		*ppDst = m_sData.ayD ;
		*pdwSize = *pdwRemain = READ_SIZE ;
		return TRUE ;
	}
	else {
		*pdwSize = *pdwRemain = 0 ;
		// ĐIŏɖ߂
		if ( m_hFile ) {
			SetFilePointer( m_hFile, 0, NULL, FILE_BEGIN ) ;
		}
		return TRUE ;
	}
}

void CBonTuner::PurgeTsStream()
{
}

void CBonTuner::Release()
{
	LogPrintf( "\fCBonTuner::Release()Ăяo\n" ) ;
	// CX^XJ
	delete this;
}

LPCTSTR CBonTuner::GetTunerName(void)
{
	LogPrintf( "\fCBonTuner::GetTunerName()Ăяo\n" ) ;
	// `[iԂ
	return TEXT("t@CĐ") ;
}

const BOOL CBonTuner::IsTunerOpening(void)
{
	return TRUE ;
}

LPCTSTR CBonTuner::EnumTuningSpace(const DWORD dwSpace)
{
	if ( dwSpace < 3 ) return TEXT("t@CĐ") ;
	else return NULL ;
}

LPCTSTR CBonTuner::EnumChannelName(const DWORD dwSpace, const DWORD dwChannel)
{
	if ( dwSpace < 3 && dwChannel < 12 ) return TEXT("t@CĐ") ;
	else return NULL ;
}

const BOOL CBonTuner::SetChannel(const DWORD dwSpace, const DWORD dwChannel)
{
	m_bChValid = TRUE ;
	return TRUE ;
}

const DWORD CBonTuner::GetCurSpace(void)
{
	// ݂̃`[jOԂԂ
	return 0 ;
}

const DWORD CBonTuner::GetCurChannel(void)
{
	// ݂̃`lԂ
	return 0 ;
}

BOOL CBonTuner::Setup( void )
{
	// ϐ
	m_dRemainBytes = 0 ;
	m_bSync = FALSE ;
	memset( m_adPacketCount, 0, sizeof(m_adPacketCount) ) ;
	m_dPcrPid = 0 ;
	m_dLastPcr = 0 ;
	m_bChValid = FALSE ;
	m_bSlow = FALSE ;
	m_dBytesPerSec = 0 ;
	// t@CJ
	if ( !GetFileName() ) return FALSE ;
	if ( !OpenFile( m_szFile ) ) {
		LogPrintf( "ERROR : Fail to open TS-file\n" ) ;
		return FALSE ;
	}
	// Xs[h̏
	if ( !StartMmTimer() ) {
		LogPrintf( "ERROR : Fail to start MM-timer\n" ) ;
		CloseFile() ;
		return FALSE ;
	}
	// L[ĎpXbh̋N
	if( !(m_hThreadEvent = CreateEvent(NULL, FALSE, FALSE, NULL ) ) ) {
		LogPrintf( "ERROR : Fail to create event to watch key\n" ) ;
		StopMmTimer() ;
		CloseFile() ;
		return FALSE ;
	}
	if ( !( m_hThread = CreateThread( NULL, 0, ThreadToWatchKey,
		this, 0, NULL ) ) ) {
		LogPrintf( "ERROR : Fail to start thread to watch key\n" ) ;
		CloseHandle( m_hThreadEvent ) ;
		StopMmTimer() ;
		CloseFile() ;
		return FALSE ;
	}
	return TRUE ;
}

void CBonTuner::Cleanup( void )
{
	// L[ĎXbȟn
	if ( m_hThread ) {
		if ( m_hThreadEvent ) ::SetEvent(m_hThreadEvent) ;
		WaitForSingleObject( m_hThread, INFINITE ) ;
		CloseHandle( m_hThread ) ;
		m_hThread = NULL ;
	}
	if(m_hThreadEvent){
		::CloseHandle(m_hThreadEvent);
		m_hThreadEvent = NULL;	
	}
	// Xs[ȟn
	StopMmTimer() ;
	// t@C
	CloseFile() ;
}

BOOL CBonTuner::GetFileName( void )
{
	BOOL bOk = FALSE ;
	// R}hC
	int nArgc = 0 ;
	LPWSTR* awszArgv = CommandLineToArgvW( GetCommandLineW(), &nArgc ) ;
	if ( awszArgv ) {
		for ( int i = 1 ; i < nArgc ; i++ ) {
			WCHAR* p = awszArgv[i] ;
			int nLen = wcslen( p ) ;
			if ( nLen > 3 && !_wcsicmp( &p[nLen-3], L".ts" ) ) {
				wcscpy_s( m_szFile, _MAX_PATH, p ) ;
				bOk = TRUE ;
			}
		}
		GlobalFree( awszArgv ) ;
	}
	if ( bOk ) return TRUE ;
	// _CAOŖ₢킹
	m_szFile[0] = 0 ;
	OPENFILENAME ofn ;
	ZeroMemory( &ofn, sizeof(ofn) ) ;
	ofn.lStructSize = sizeof(ofn) ;
	ofn.hwndOwner = NULL ;
	ofn.lpstrFile = m_szFile ;
	ofn.nMaxFile = _MAX_PATH ;
	ofn.lpstrFilter = L"TS-File\0*.ts\0\0" ;
	ofn.nFilterIndex = 0 ;
	ofn.lpstrFileTitle = NULL;
	ofn.nMaxFileTitle = 0;
	ofn.lpstrInitialDir = NULL;
	ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;
	if ( GetOpenFileNameW(&ofn) ) {
		wcscpy_s( m_szFile, _MAX_PATH, ofn.lpstrFile ) ;
		bOk = TRUE ;
	}
	if ( bOk ) return TRUE ;
	return FALSE ;
}

BOOL CBonTuner::StartMmTimer( void )
{
	// Xs[hp̃Z}tH[
	if ( !( m_hSemaphore =
		CreateSemaphore( NULL, 0, 50, NULL ) ) ) return FALSE ;
	// Xs[hp̃}`fBA^C}[
	if ( m_uTimerId = timeSetEvent( 10, 1, &CBonTuner::TimerProc, 0,
		TIME_PERIODIC|TIME_CALLBACK_FUNCTION ) ) return TRUE ;
	else {
		CloseHandle( m_hSemaphore ) ;
		m_hSemaphore = NULL ;
		return FALSE ;
	}
}

void CBonTuner::StopMmTimer( void )
{
	// Xs[hp̃}`fBA^C}[
	if ( m_uTimerId ) {
		timeKillEvent( m_uTimerId ) ;
		m_uTimerId = 0 ;
	}
	// Xs[hp̃Z}tH[
	if ( m_hSemaphore ) {
		CloseHandle( m_hSemaphore ) ;
		m_hSemaphore = NULL ;
	}
}

void CALLBACK CBonTuner::TimerProc(UINT wTimerID, UINT msg,
    DWORD dwUser, DWORD dw1, DWORD dw2)
{
	// X[Đp
	static int nDivider = 0 ;
	if ( m_pThis->m_bSlow ) {
		if ( ++nDivider >= 3 ) {
			nDivider = 0 ;
			return ;
		}
	}
	ReleaseSemaphore( m_pThis->m_hSemaphore, 1, NULL ) ;
}

BOOL CBonTuner::OpenFile( LPCWSTR pszFile )
{
	m_hFile = CreateFileW( pszFile, GENERIC_READ, FILE_SHARE_READ,
		NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL ) ;
	if ( m_hFile == INVALID_HANDLE_VALUE ) {
		WCHAR szMsg[_MAX_PATH+100] ;
		wcscpy_s( szMsg, 100, L"t@CJ܂B\r" ) ;
		wcscat_s( szMsg, _MAX_PATH+100, pszFile ) ;
		MessageBoxW( NULL, szMsg, L"BonDriver_File.dll", MB_ICONSTOP ) ;
		m_hFile = NULL ;
		return FALSE ;
	}
	return TRUE ;
}

void CBonTuner::CloseFile( void )
{
	if ( m_hFile ) {
		CloseHandle( m_hFile ) ;
		m_hFile = NULL ;
	}
}

BOOL CBonTuner::ReadFile( void )
{
	// t@Cǂݍ
	if ( !m_hFile ) return FALSE ;
	DWORD dReadBytes = 0 ;
	if ( !::ReadFile( m_hFile, m_sData.ayD, READ_SIZE,
		&dReadBytes, NULL ) || dReadBytes != READ_SIZE ) {
		return FALSE ;
	}
	m_dBytesPerSec += READ_SIZE ;
	// pPbgPʂɕ
	BYTE* pyData = &m_sData.ayD[-(int)m_dRemainBytes] ;
	DWORD dBytes = READ_SIZE + m_dRemainBytes ;
	DWORD dPos = 0 ;
	while ( dBytes - dPos >= PSIZE + 1 ) {
		// 
		if ( pyData[dPos] != SYNC || pyData[dPos+PSIZE] != SYNC ) m_bSync = FALSE ;
		if ( !m_bSync ) DebugPrintF( "Re-Sync\n" ) ;
		while ( !m_bSync ) {
			if ( dBytes - dPos < PSIZE * SYNC_COUNT ) break ;
			DWORD i ;
			for ( i = 0 ; i < PSIZE * SYNC_COUNT ; i += PSIZE ) {
				if ( pyData[dPos+i] != SYNC ) break ;
			}
			if ( i >= PSIZE * SYNC_COUNT ) m_bSync = TRUE ;
			else dPos++ ;
		}
		if ( !m_bSync ) {
			m_dRemainBytes = 0 ;
			return TRUE ;
		}
		// pPbg̏
		ProcessPacket( &pyData[dPos] ) ;
		// ̃pPbg
		dPos += PSIZE ;
	}
	// [̎cɉ
	if ( m_dRemainBytes = dBytes - dPos ) {
		memcpy( &m_sData.ayR[PSIZE-m_dRemainBytes],
			&m_sData.ayD[READ_SIZE-m_dRemainBytes], m_dRemainBytes ) ;
	}
	return TRUE ;
}

void CBonTuner::ProcessPacket( const BYTE* pyData )
{
	// PCR܂ރpPbg͖
	Packet* p = (Packet*)pyData ;
	if ( p->sync != SYNC ) return ;
	if ( p->transport_error_indicator ) return ;
	WORD PID = ( (WORD)p->PID_h << 8 ) + p->PID_l ;
	if ( PID == 0x1fff ) return ;
	if ( p->adaptation_field_control != 2 &&
		p->adaptation_field_control != 3 ) return ;
	if ( !p->PCR_flag ) return ;
	// ݊ĎPIDH
	if ( PID != m_dPcrPid ) {
		DWORD dDiff = m_adPacketCount[PID] - m_adPacketCount[m_dPcrPid] ;
		if ( dDiff < 5 ) {
			m_adPacketCount[PID]++ ;
			return ;
		}
		if ( dDiff > 5 ) {
			m_adPacketCount[PID] = m_adPacketCount[m_dPcrPid] ;
			return ;
		}
		m_dPcrPid = PID ;
	}
	m_adPacketCount[PID]++ ;
	// PCRl擾
	DWORD PCR_90KHz = ( p->PCR_90KHz_1 << 25 ) |
		( p->PCR_90KHz_2 << 17 ) | ( p->PCR_90KHz_3 << 9 ) |
		( p->PCR_90KHz_4 << 1 ) | ( p->PCR_90KHz_5 << 0 ) ;
	//DebugPrintF( "%08X\n", PCR_90KHz ) ;
	// PCR傫ςꍇ͖
	DWORD dDiffPcr = PCR_90KHz - m_dLastPcr ;
	if ( dDiffPcr > 500 * 90 ) {
		m_dLastPcr = PCR_90KHz ;
		return ;
	}
	// PCR̕ω҂
	DWORD dDiff10ms = dDiffPcr / ( 10 * 90 ) ;
	m_dLastPcr = m_dLastPcr + dDiff10ms * ( 10 * 90 ) ;
	while( dDiff10ms ) {
		WaitForSingleObject( m_hSemaphore, 20 ) ;
		dDiff10ms-- ;
	}
}

DWORD CBonTuner::ThreadToWatchKey(LPVOID lpParameter)
{
	CBonTuner* pThis = (CBonTuner*)lpParameter ;
	static int nSpeedCnt = 0 ;
	static int nBytesPerSec = 0 ;
	static DWORD dKeyInterval = 0 ;
	while ( TRUE ) {
		if ( WaitForSingleObject( pThis->m_hThreadEvent, 50 ) != WAIT_TIMEOUT ) break ;
		if ( !pThis->m_hFile ) continue ;
		// TSox̊Ď
		if ( ++nSpeedCnt >= 20 ) {
			nSpeedCnt = 0 ;
			nBytesPerSec = pThis->m_dBytesPerSec ;
			pThis->m_dBytesPerSec = 0 ;
		}
		// ÕL[0.5b̓L[𖳎
		if ( dKeyInterval == 10 ) MessageBeep( MB_OK ) ;
		if ( dKeyInterval ) {
			dKeyInterval-- ;
			continue ;
		}
		// Ctrl+AltĂ邩
		if ( GetKeyState( VK_CONTROL ) >= 0 || GetKeyState( VK_MENU ) >= 0 ) continue ;
		// ShiftĂ邩
		LONG lP = 0, lM = -1 ;
		BOOL bShift = ( GetKeyState( VK_SHIFT ) < 0 ) ;
		// 'S' X[
		if ( GetKeyState( 'S' ) < 0 ) {
			if ( !bShift ) pThis->m_bSlow = TRUE ;
			else pThis->m_bSlow = FALSE ;
			dKeyInterval = 10 ;
			continue ;
		}
		// 'HOME' ŏ/Ō10bO
		if ( GetKeyState( VK_HOME ) < 0 ) {
			if ( !bShift ) SetFilePointer( pThis->m_hFile, 0, &lP, FILE_BEGIN ) ;
			else SetFilePointer( pThis->m_hFile, -nBytesPerSec * 10, &lM, FILE_END ) ;
			dKeyInterval = 10 ;
			continue ;
		}
		// '1' 5b
		if ( GetKeyState( '1' ) < 0 ) {
			if ( !bShift ) SetFilePointer( pThis->m_hFile,  nBytesPerSec * 5, &lP, FILE_CURRENT ) ;
			else           SetFilePointer( pThis->m_hFile, -nBytesPerSec * 5, &lM, FILE_CURRENT ) ;
			dKeyInterval = 10 ;
			continue ;
		}
		// '2' 15b
		if ( GetKeyState( '2' ) < 0 ) {
			if ( !bShift ) SetFilePointer( pThis->m_hFile,  nBytesPerSec * 15, &lP, FILE_CURRENT ) ;
			else           SetFilePointer( pThis->m_hFile, -nBytesPerSec * 15, &lM, FILE_CURRENT ) ;
			dKeyInterval = 10 ;
			continue ;
		}
		// '3' 1
		if ( GetKeyState( '3' ) < 0 ) {
			if ( !bShift ) SetFilePointer( pThis->m_hFile,  nBytesPerSec * 60, &lP, FILE_CURRENT ) ;
			else           SetFilePointer( pThis->m_hFile, -nBytesPerSec * 60, &lM, FILE_CURRENT ) ;
			dKeyInterval = 10 ;
			continue ;
		}
		// '4' 5
		if ( GetKeyState( '4' ) < 0 ) {
			if ( !bShift ) SetFilePointer( pThis->m_hFile,  nBytesPerSec * 300, &lP, FILE_CURRENT ) ;
			else           SetFilePointer( pThis->m_hFile, -nBytesPerSec * 300, &lM, FILE_CURRENT ) ;
			dKeyInterval = 10 ;
			continue ;
		}
	}
	return 0 ;
}
