// BonTuner.h: CBonTuner NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#pragma once
#include "IBonDriver2.h"

// 萔`
#define READ_SIZE (64*1024)
#define PSIZE (188)
#define SYNC (0x47)
#define SYNC_COUNT (10)

class CBonTuner : public IBonDriver2
{
// RXgN^EfXgN^
public:
	CBonTuner();
	virtual ~CBonTuner();

// IBonDriver
public:
	const BOOL OpenTuner(void);
	void CloseTuner(void);
	const BOOL SetChannel(const BYTE bCh);
	const float GetSignalLevel(void);
	const DWORD WaitTsStream(const DWORD dwTimeOut = 0);
	const DWORD GetReadyCount(void);
	const BOOL GetTsStream(BYTE *pDst, DWORD *pdwSize, DWORD *pdwRemain);
	const BOOL GetTsStream(BYTE **ppDst, DWORD *pdwSize, DWORD *pdwRemain);
	void PurgeTsStream(void);
	void Release(void);

// IBonDriver2(b)
public:
	LPCTSTR GetTunerName(void);
	const BOOL IsTunerOpening(void);
	LPCTSTR EnumTuningSpace(const DWORD dwSpace);
	LPCTSTR EnumChannelName(const DWORD dwSpace, const DWORD dwChannel);
	const BOOL SetChannel(const DWORD dwSpace, const DWORD dwChannel);
	const DWORD GetCurSpace(void);
	const DWORD GetCurChannel(void);

// [`
private:
	BOOL Setup( void ) ;
	void Cleanup( void ) ;
	BOOL GetFileName( void ) ;
	BOOL StartMmTimer( void ) ;
	void StopMmTimer( void ) ;
	static void CALLBACK TimerProc(UINT wTimerID, UINT msg, 
	    DWORD dwUser, DWORD dw1, DWORD dw2) ;
	BOOL OpenFile( LPCWSTR pszFile ) ;
	void CloseFile( void ) ;
	BOOL ReadFile( void ) ;
	void ProcessPacket( const BYTE* pyData ) ;
	static DWORD WINAPI ThreadToWatchKey( LPVOID lpParameter ) ;
// g̃|C^Enh
public:
	static CBonTuner * m_pThis;
	static HINSTANCE m_hModule;
// pϐ
private:
	// t@CǗ
	WCHAR m_szFile[_MAX_PATH] ;
	HANDLE m_hFile ;
	// TSf[^Ǘ
	struct {
		BYTE ayR[PSIZE] ;
		BYTE ayD[READ_SIZE] ;
	} m_sData ;
	DWORD m_dRemainBytes ;
	BOOL m_bSync ;
	DWORD m_adPacketCount[0x2000] ;
	DWORD m_dPcrPid ;
	DWORD m_dLastPcr ;
	BOOL m_bChValid ;
	// Xs[hǗ
	UINT m_uTimerId ;
	HANDLE m_hSemaphore ;
	BOOL m_bSlow ;
	DWORD m_dBytesPerSec ;
	// L[ĎpXbh̊Ǘ
	HANDLE m_hThreadEvent ;
	HANDLE m_hThread ;
};
